#include <stdio.h>
#include <stdlib.h>

typedef struct strom
{
    int hodnota;
    struct strom *levy, *pravy;
} typStrom;

void vloz(typStrom **s, int x)
{
    typStrom *p;

    if (*s==NULL)
    {
        p=(typStrom *) malloc(sizeof(typStrom));
        p->hodnota=x;
        p->levy=NULL;
        p->pravy=NULL;
        *s=p;
    }
    else
       if (x<(*s)->hodnota) vloz(&((*s)->levy),x);
           else vloz(&((*s)->pravy),x);
}

typStrom *najdiI(typStrom *s, int x)
{
    unsigned short nalezen=0;

    while (s!=NULL && !nalezen)
    {
        if (s->hodnota==x) nalezen=1;
           else
           {
               if (x<s->hodnota) s=s->levy;
                  else s=s->pravy;
           }
    }
    return s;
}

typStrom *najdiR(typStrom *s, int x)
{
    if (s!=NULL)
    {
        if (s->hodnota==x)
           return s;
           else
           {
               if (x<s->hodnota) return najdiR(s->levy,x);
                  else return najdiR(s->pravy,x);
           }
    }
    else return NULL;
}

void vypisPrefix(typStrom *s)
{
    if (s!=NULL)
    {
        printf("%4d",s->hodnota);
        vypisPrefix(s->levy);
        vypisPrefix(s->pravy);
    }
}

void vypisInfix(typStrom *s)
{
    if (s!=NULL)
    {
        vypisInfix(s->levy);
        printf("%4d",s->hodnota);
        vypisInfix(s->pravy);
    }
}

void vypisPostfix(typStrom *s)
{
    if (s!=NULL)
    {
        vypisPostfix(s->levy);
        vypisPostfix(s->pravy);
        printf("%4d",s->hodnota);
    }
}

typedef struct prvek
{
    typStrom *hodnota;
    struct prvek *naslednik;
} typPrvek;

typedef struct fronta
{
    typPrvek *celo, *konec;
} typFronta;

void init(typFronta *f)
{
    f->celo=NULL;
    f->konec=NULL;
}

int empty(typFronta f)
{
    return f.celo==NULL;
}

void enqueue(typFronta *f, typStrom *x)
{
    typPrvek *p;

    p=(typPrvek *)malloc(sizeof(typPrvek));
    p->hodnota=x;
    p->naslednik=NULL;
    if (empty(*f))
       f->celo=p;
       else f->konec->naslednik=p;
    f->konec=p;
}

int dequeue(typFronta *f, typStrom **x)
{
    typPrvek *p;

    if (empty(*f)) return 0;

    p=f->celo;
    *x=p->hodnota;
    f->celo=p->naslednik;
    if (empty(*f))
       f->konec=NULL;
    free(p);

    return 1;
}

void vypisLevel(typStrom *s)
{
    typFronta fr;
    typStrom *uk;

    init(&fr);
    if (s!=NULL)
    {
        printf("%d",s->hodnota);
        enqueue(&fr,s);
        while (!empty(fr))
        {
            dequeue(&fr,&uk);
            if (uk->levy!=NULL)
            {
                printf("%4d",uk->levy->hodnota);
                enqueue(&fr,uk->levy);
            }
            if (uk->pravy!=NULL)
            {
                printf("%4d",uk->pravy->hodnota);
                enqueue(&fr,uk->pravy);
            }

        }
    }
}

int main(void)
{
    typStrom *koren, *prvek;
    int k;

    koren=NULL;

    vloz(&koren,50); vloz(&koren,30); vloz(&koren,200);
    vloz(&koren,20); vloz(&koren,40); vloz(&koren,150);
    vloz(&koren,300); vloz(&koren,10); vloz(&koren,25);
    vloz(&koren,35); vloz(&koren,45); vloz(&koren,120);
    vloz(&koren,170); vloz(&koren,270); vloz(&koren,400);

    puts("Vypis prvku BVS ve formatu prefix:");
    vypisPrefix(koren);
    puts("\n");

    puts("Vypis prvku BVS ve formatu infix:");
    vypisInfix(koren);
    puts("\n");

    puts("Vypis prvku BVS ve formatu postfix:");
    vypisPostfix(koren);
    puts("\n");

    puts("Vypis prvku BVS po jednotlivych urovnich:");
    vypisLevel(koren);
    puts("\n");

    k=125;

    prvek=najdiI(koren,k);
    if (prvek==NULL) printf("Prvek %d ve strome neni\n",k);
       else printf("Prvek %d byl nalezen\n",prvek->hodnota);

    prvek=najdiR(koren,k);
    if (prvek==NULL) printf("Prvek %d ve strome neni\n",k);
       else printf("Prvek %d byl nalezen\n",prvek->hodnota);

    return 0;
}
