/*
    Program demonstrujici cinnost fronty realizovane pomoci
    dynamickych promennych.
*/

#include <stdio.h>
#include <stdlib.h>

typedef struct prvek
{
    int hodnota;
    struct prvek *naslednik;
} typPrvek;

typedef struct fronta
{
    typPrvek *celo, *konec;
} typFronta;

void init(typFronta *f)
{
    f->celo=NULL;
    f->konec=NULL;
}

int empty(typFronta f)
{
    return f.celo==NULL;
}

void enqueue(typFronta *f, int x)
{
    typPrvek *p;

    p=(typPrvek *)malloc(sizeof(typPrvek));
    p->hodnota=x;
    p->naslednik=NULL;
    if (empty(*f))
       f->celo=p;
       else f->konec->naslednik=p;
    f->konec=p;
}

int dequeue(typFronta *f, int *x)
{
    typPrvek *p;

    if (empty(*f)) return 0;

    p=f->celo;
    *x=p->hodnota;
    f->celo=p->naslednik;
    if (empty(*f))
       f->konec=NULL;
    free(p);

    return 1;
}

int main(void)
{
    typFronta fr;
    int hodnota;

    init(&fr);

    for (hodnota=1; hodnota<=10; hodnota++)
      enqueue(&fr,hodnota);

    puts("Prvky, ktere byly ulozeny ve fronte:");
    while (dequeue(&fr,&hodnota))
      printf("%4d",hodnota);
    putchar('\n');

    return 0;
}
